#include "filehandler.h"
#include <QFile>
#include <QIODevice>
#include <QTextStream>
#include <QDir>
#include <QDateTime>

#define SOURCES_FILE "/etc/apt/sources.list"
#define SOURCES_DIR "/etc/apt/sources.list.d"
#define CACHE_PATH "/var/cache/pardus/pardus-store/"
#define USER_CACHE_PATH "/.cache/pardus/pardus-store/"

FileHandler::FileHandler(QObject *parent) : QObject(parent)
{

}

void FileHandler::correctSources()
{
    QFile file(SOURCES_FILE);
    if (!file.open(QIODevice::WriteOnly | QIODevice::Text)) {
        emit correctingSourcesFinishedWithError(file.errorString());
        return;
    }

    QDir dir(SOURCES_DIR);
    dir.setNameFilters(QStringList() << "*.*");
    dir.setFilter(QDir::Files);

    foreach(QString dirFile, dir.entryList())
    {
        if(!dir.remove(dirFile)) {
            emit correctingSourcesFinishedWithError("Could not delete " + dirFile);
            return;
        }
    }

    QDateTime time = QDateTime::currentDateTime();

    QTextStream out(&file);
    out << "### The Official Pardus Package Repositories ###" << "\n\n"
        << "deb http://depo.pardus.org.tr/pardus ondokuz main contrib non-free" << "\n"
        << "# deb-src http://depo.pardus.org.tr/pardus ondokuz main contrib non-free" << "\n\n"
        << "deb http://depo.pardus.org.tr/guvenlik ondokuz main contrib non-free" << "\n"
        << "# deb-src http://depo.pardus.org.tr/guvenlik ondokuz main contrib non-free" << "\n\n"
        << "### This section generated by Pardus Store at "
        << time.toString("hh:mm:ss - dd.MM.yyyy") << " ###\n";

    file.close();
    emit correctingSourcesFinished();
}

void FileHandler::clearCache()
{
    QString user = "root";
    user = qgetenv("USER");
    if (user.isEmpty()) {
        user = qgetenv("USERNAME");
    }
    if (user != "root"){
        QDir dir(QDir::homePath().append(QString(USER_CACHE_PATH)));
        if(!dir.removeRecursively()) {
            emit clearCacheFinishedWithError("Could not delete " + QDir::homePath().append(QString(USER_CACHE_PATH)));
            return;
        }
        emit clearCacheFinished();
    }
    else {
         QDir dir(CACHE_PATH);
         QDir dir1(QDir::homePath().append(QString(USER_CACHE_PATH)));
         // dir1 is /root/.cache/pardus/pardus-store/  (image caches)
         // dir1 clearing too because QStandardPaths: XDG_RUNTIME_DIR not set, defaulting to '/tmp/runtime-root'
         if(!dir.removeRecursively()) {
             emit clearCacheFinishedWithError("Could not delete " + QString(CACHE_PATH));
             return;
         }
         if(!dir1.removeRecursively()) {
             emit clearCacheFinishedWithError("Could not delete " + QDir::homePath().append(QString(USER_CACHE_PATH)));
             return;
         }
         emit clearCacheFinished();
    }
}
